<template>
	<div class="common-page device-manage">

    	<!-- 表格 -->
		<div class="panel-bottom page-row">
			<h3>采点管理</h3>
			<div class="ctin-box">
				<div class="content-within">
					<div class="content-fix">
						<div class="toolbar">
							<el-button size="mini" type="primary" icon="el-icon-plus" @click="toAdd">新增</el-button>
						</div>
						<div class="content">
							<el-table :data="tableData" v-loading="loading" border style="width:auto" :row-class-name="tableRowClassName">
								<el-table-column prop="name" label="采点名称" align="center"></el-table-column>
								<el-table-column prop="areaName" label="所属采区" align="center"></el-table-column>
								<el-table-column prop="areashovel" label="铲车名称" align="center"></el-table-column>
								<el-table-column prop="arearesources" label="矿种" align="center"></el-table-column>
								<el-table-column prop="areaore" label="是否配矿" align="center"></el-table-column>
								<el-table-column prop="areapriority" label="优先级" align="center"></el-table-column>
								<el-table-column label="操作" align="center" fixed="right">
									<template slot-scope="scope">
										<el-button size="mini" type="primary" icon="el-icon-edit" @click="toEdit(scope.row)"></el-button>
										<el-button size="mini" type="danger" icon="el-icon-delete" @click="toDelete(scope.row)"></el-button>
										<el-button size="mini" type="success" icon="el-icon-more" v-show="scope.row.areaore == '是'" @click="showGradeTable(scope.row)"></el-button>
									</template>
								</el-table-column>
							</el-table>
							<!--分页组件-->
							<el-pagination :total="total" :current-page="page" style="margin-top: 8px;" layout="total, prev, pager, next, sizes" @size-change="sizeChange" @current-change="pageChange" />
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- 表单渲染 -->
		<el-dialog append-to-body :close-on-click-modal="true" :before-close="cancelForm" :visible.sync="form.visible" :title="form.title" width="700px">
			<el-form :model="form.item" :rules="rules" ref="form1" :inline="true" size="small" label-width="150px">
				<el-form-item label="采点名称" prop="name">
					<el-input v-model="form.item.name" style="width:280px;" placeholder="请输入采点名称"/>
				</el-form-item>
				<el-form-item label="所属采区" prop="areaName">
					<el-select v-model="form.item.areaName" placeholder="请选择所属采区" style="width:280px;">
						<el-option v-for="(obj,index) in caidianAreaInformationData" :label="obj.name" :value="obj.name" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="铲车" prop="areashovel">
					<el-select v-model="form.item.areashovel" placeholder="请选择铲车" style="width:280px;">
						<el-option v-for="(obj,index) in dianchanCarInformationData" :label="obj.number" :value="obj.number" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="矿种" prop="arearesources">
					<el-select v-model="form.item.arearesources" placeholder="请选择矿种" style="width:280px;">
						<el-option label="废石" value="废石"></el-option>
						<el-option label="矿石" value="矿石"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="是否配矿" prop="areaore">
					<el-select v-model="form.item.areaore" placeholder="请选择是否配矿" style="width:280px;">
						<el-option label="是" value="是"></el-option>
						<el-option label="否" value="否"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="优先级" prop="areapriority">
					<el-input-number v-model="form.item.areapriority" :min="1" :max="10" label=""></el-input-number>
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button type="text" @click="cancelForm">取消</el-button>
				<el-button :loading="form.status.cu === 2" type="primary" @click="submitForm('form1', form.item)">确认</el-button>
			</div>
		</el-dialog>

		<!-- 品位设置 -->
		<el-dialog title="品位设置" :visible.sync="dialogTableVisible">
			<div class="toolbar" style="margin-bottom:15px;">
				<el-button size="mini" type="primary" icon="el-icon-plus" @click="gradeToAdd">新增</el-button>
			</div>
			<el-table :data="gridData" border v-loading="gradeLoading">
				<el-table-column property="name" label="品位名称" align="center"></el-table-column>
				<el-table-column property="content" label="含量" align="center"></el-table-column>
				<el-table-column property="unit" label="单位" align="center"></el-table-column>
				<el-table-column label="操作" align="center" fixed="right">
					<template slot-scope="scope">
						<el-button size="mini" type="primary" icon="el-icon-edit" @click="gradeToEdit(scope.row)"></el-button>
						<el-button size="mini" type="danger" icon="el-icon-delete" @click="gradeToDelete(scope.row)"></el-button>
					</template>
				</el-table-column>
			</el-table>
		</el-dialog>

		<!-- 品位设置表单 -->
		<el-dialog :title="gradeFrom.title" :before-close="gradeCancelForm" :visible.sync="gradeFrom.visible" width="700px">
			<el-form :model="gradeFrom.item" :inline="true" ref="form2" size="small" label-width="150px">
				<el-form-item label="品位名称">
					<el-input v-model="gradeFrom.item.name" style="width:260px;" placeholder="请输入品位名称"></el-input>
				</el-form-item>
				<el-form-item label="含量">
					<el-input v-model="gradeFrom.item.content" style="width:260px;" placeholder="请输入含量"></el-input>
				</el-form-item>
				<el-form-item label="单位">
					<el-input v-model="gradeFrom.item.unit" style="width:260px;" placeholder="请输入单位"></el-input>
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="gradeCancelForm">取 消</el-button>
				<el-button :loading="gradeFrom.status.cu === 2" type="primary" @click="gradeSubmitForm('form2', gradeFrom.item)">确 定</el-button>
			</div>
		</el-dialog>

	</div>
</template>

<script>
import { Tools, HttpReq, Dates} from '@/assets/js/common.js';

export default {
	name: 'RegionalCaiDian',
	components: {},
	data() {
		return {
			loading: false,
			page: 1,
			size: 10,
			total: 0,
			query:{},
			tableData: [],
			UnloadingPointData:[],
			caidianAreaInformationData:[],
			dianchanCarInformationData:[],
			gradeQueryId:0,
			form: {
				title:'新增采点',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			},
			rules: {
				name: [
					{required: true, message: '请输入采点名称', trigger: 'blur' }
				],
				areashovel: [
					{required: true, message: '请选择铲车', trigger: 'change' }
				],
			},

			
			
			//品味设置数据
			dialogTableVisible: false,
			gridData: [],
			gradeLoading: false,
			gradeQueryId:0,
			gradeFrom:{
				title:'新增品位',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			}


		}
	},
	mounted() {
		var that = this;
		this.$nextTick(() => {
			this.loadData();
		})
	},
	methods: {
		loadData() {
			var sort = 'id,desc';
			var param = this.query;
			param.page = this.page - 1;
			param.size = this.size;
			param.sort = sort;
			
			this.$nextTick(()=>{
				HttpReq.truckDispatching.RegionalCaiDianQuery(param).then((res) => {
					if(res.code == 200){
						this.loading = false;
						this.tableData = res.data.content;
						this.total = res.data.totalElements;
					}
				})
				//获取区域信息
				HttpReq.truckDispatching.onlyGetMiningAreaQuery({size:9999}).then((res) => {
					this.caidianAreaInformationData = res;
				})
				//获取铲车车辆信息
				HttpReq.truckDispatching.carInformationQuery({size:9999,carclass:'铲车'}).then((res) => {
					if(res.code == 200){
						this.dianchanCarInformationData = res.data.content;
					}
				})
			})

		},
		tableRowClassName({row, rowIndex}) {
			if (rowIndex === 1) {
				return 'warning-row';
			} else if (rowIndex === 3) {
				return 'success-row';
			}
			return '';
		},	
		cancelForm(a, b, c){
			this.form.visible = false;
		},
		toAdd() {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '新增采点';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.reqType = 'add';
			this.form.item = {};
		},
		toEdit(item) {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '修改采点';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.item = {...item};
			this.form.reqType = 'edit';
		},
		toDelete(item) {
			var id = item.id;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.reqRemoveProject([id])
			}).catch((e) => {})
		},
		pageChange(e) {
			this.page = e
			this.loadData()
		},
		sizeChange(e) {
			this.page = 1
			this.size = e
			this.loadData()
		},
		submitForm(validateName, item){
			if(!this.form.status.cu){
				this.form.status.cu = 2;
				this.$refs[validateName].validate(valid => {
					if(valid){
						if(this.form.reqType === 'add'){
							this.reqAddItem(this.form, item)
						}else{
							this.reqUpdateItem(this.form, item)
						}
					}else{
						this.form.status.cu = 0
					}
				});
			};
		},
		//新增采点
		reqAddItem(form, item){
			let lastData = {...item};
			HttpReq.truckDispatching.RegionalCaiDianAdd(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '采点新增成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				form.status.cu = 0
			});
		},
		//修改采点
		reqUpdateItem(form, item){
			let lastData = {...item};
			HttpReq.truckDispatching.RegionalCaiDianUpdate(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '采点修改成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				form.status.cu = 0
			});
		},
		//删除采点
		reqRemoveProject(item){
			HttpReq.truckDispatching.RegionalCaiDianDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadData();
			})
		},



		//品味设置方法
		showGradeTable(row){
			this.dialogTableVisible = true;
			this.gradeQueryId = row.id;
			this.loadGradeData();
		},
		//获取品味设置数据
		loadGradeData(){
			var sort = 'id,desc';
			var param = {};
			param.sort = sort;
			param.areaId = this.gradeQueryId;
			
			this.$nextTick(()=>{
				HttpReq.truckDispatching.RegionalInformationGradeQuery(param).then((res) => {
					if(res.code == 200){
						this.gradeLoading = false;
						this.gridData = res.data.content;
					}
				})
			})
		},
		gradeCancelForm(a, b, c){
			this.gradeFrom.visible = false;
		},
		gradeSubmitForm(validateName, item){
			if(!this.gradeFrom.status.cu){
				this.gradeFrom.status.cu = 2;
				this.$refs[validateName].validate(valid => {
					if(valid){
						if(this.gradeFrom.reqType === 'add'){
							this.gradeReqAddItem(this.gradeFrom, item)
						}else{
							this.gradeReqUpdateItem(this.gradeFrom, item)
						}
					}else{
						this.gradeFrom.status.cu = 0
					}
				});
			};
		},
		gradeToAdd() {
			// 请除表单验证
			this.$refs['form2'] && this.$refs['form2'].clearValidate();
			this.gradeFrom.title = '新增品味';
			this.gradeFrom.status.cu = 0;
			this.gradeFrom.visible = true;
			this.gradeFrom.reqType = 'add';
			this.gradeFrom.item = {};
		},
		gradeToEdit(item) {
			// 请除表单验证
			this.$refs['form2'] && this.$refs['form2'].clearValidate();
			this.gradeFrom.title = '修改品位设置';
			this.gradeFrom.status.cu = 0;
			this.gradeFrom.visible = true;
			this.gradeFrom.item = {...item};
			this.gradeFrom.reqType = 'edit';
		},
		gradeToDelete(item) {
			var id = item.id;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.gradeReqRemoveProject([id])
			}).catch((e) => {})
		},
		//新增品味设置
		gradeReqAddItem(gradeFrom, item){
			let lastData = {...item};
			lastData.areaId = this.gradeQueryId;
			HttpReq.truckDispatching.RegionalInformationGradeAdd(lastData).then((res) => {
				gradeFrom.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '品味设置新增成功！',
						type: 'success',
						duration: 2500
					});
					this.loadGradeData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				gradeFrom.status.cu = 0
			});
		},
		//修改品味设置
		gradeReqUpdateItem(gradeFrom, item){
			let lastData = {...item};
			HttpReq.truckDispatching.RegionalInformationGradeUpdate(lastData).then((res) => {
				gradeFrom.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '品味设置修改成功！',
						type: 'success',
						duration: 2500
					});
					this.loadGradeData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
					this.loadGradeData()
				}
			}).catch(function(error) {
				gradeFrom.status.cu = 0
			});
		},
		//删除品味设置
		gradeReqRemoveProject(item){
			HttpReq.truckDispatching.RegionalInformationGradeDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadGradeData();
			})
		},



	}
}
</script>

<style rel="stylesheet/scss" lang="scss" scope>
	.el-table .warning-row {
		background: oldlace;
	}
	.el-table .success-row {
		background: #f0f9eb;
	}
	
	.device-manage{
		.panel-bottom{
			.el-button{margin:2px 0;padding:6px 15px;font-size:14px;}
			.btn-groub2{
				display:inline-block;
				.el-button{margin:2px 0;padding:6px 15px;font-size:15px;}
				.el-button--warning {
					background-color: #e6a23c;
					border-color: #e6a23c;
				}
				.el-button--warning:focus,.el-button--warning:hover{background:#ebb563;border-color:#ebb563;}
			}
		}
	}
	
	.ecahrt1-dialog{
		display:flex;align-items:center;
		.el-dialog{
			margin-top:inherit !important;display:table !important;width:fit-content;
			.el-form-item{margin-right:0;}
		}

		.el-dialog__header{height:0;padding:0;display:block;}
		.form-body{
			border:1px solid #999;width:800px;height:500px;position:relative;
			>div{position:absolute;top:0;left:0;height:100%;width:100%;}
		}
	}
</style>
